<template>
  <dashboard-layout>
    <Search
      :params="params"
      @onAdd="onAdd"
      @onChangeParams="onChangeParams"
      @onSearch="onSearch"
      @onClearSearch="onClearSearch"
    />
    <List
      :customers="customers"
      :pagination="pagination"
      :page="params.page"
      @onChangePage="onChangeParams"
    />
    <DialogData
      :dialogData="dialogData"
      @onChangeDialogData="onChangeDialogData"
      @onReloadList="onSearch"
    />
  </dashboard-layout>
</template>

<script>
import Search from "./../components/customer/table/Search.vue";
import List from "./../components/customer/table/List.vue";
import DialogData from "../components/customer/data/DialogData.vue";
import customerService from "../services/customerService";

export default {
  components: {
    Search,
    List,
    DialogData,
  },
  data() {
    return {
      params: {
        page: 1,
        customerName: "",
        email: "",
        address: "",
        isActive: "",
      },
      customers: [],
      pagination: {
        from: 0,
        to: 0,
        total: 0,
        currentPage: 0,
        lastPage: 0,
      },
      dialogData: false,
    };
  },
  methods: {
    async fetchData() {
      this.$store.commit("loading", true);
      await customerService
        .getList(this.params)
        .then((response) => {
          this.$store.commit("loading", false);
          const responseData = response.data;
          this.customers = responseData.data;
          this.pagination.from = responseData.from;
          this.pagination.to = responseData.to;
          this.pagination.total = responseData.total;
          this.pagination.currentPage = responseData.currentPage;
          this.pagination.lastPage = responseData.lastPage;
        })
        .catch((error) => {
          this.$store.commit("loading", false);
          let msgError = "";
          if (error.response.status === 422) {
            const dataErrors = error.response.data.errors;
            let errors = [];
            for (const [key, value] of Object.entries(dataErrors)) {
              errors.push(value);
            }
            msgError = errors.toString();
          } else {
            msgError = error.response.data.message;
          }
          this.$store.commit("showMessageError", msgError);
        });
    },
    onChangeParams({ key, value }) {
      this.params[key] = value;
      if (key === "page") {
        this.fetchData();
      }
    },
    onSearch() {
      this.params.page = 1;
      this.fetchData();
    },
    onClearSearch() {
      this.params = {
        page: 1,
        customerName: "",
        email: "",
        address: "",
        isActive: "",
      };
      this.fetchData();
    },
    onAdd() {
      this.onChangeDialogData(true);
    },
    onChangeDialogData(value) {
      this.dialogData = value;
    },
  },
  async created() {
    await this.fetchData();
  },
};
</script>
